1 REM ERATOSTHENES SIEVE
2 REM http://en.wikipedia.org/wiki/Sieve_of_Eratosthenes
3 REM http://rosettacode.org/wiki/Sieve_of_Eratosthenes#Applesoft_BASIC

10 CALL -198:REM BEEP!
11 LET TRUE=(1=1):LET FALSE=(1<>1):LET LIMIT=1024
12 LET COUNT=0
13 DIM FLAG(LIMIT)
14 REM 0 E 1 NAO SAO PRIMOS, POR DEFINICAO
15 FOR I=0 TO 1: LET FLAG(I) = FALSE : NEXT I
16 FOR I=2 TO LIMIT: LET FLAG(I) = TRUE : NEXT I
20 GOTO 1000

100 REM INTBASIC NAO TEM RAIZ QUADRADA...
101 REM http://www.lbebooks.com/downloads/exportal/Verilog_NEXYS_Example24.pdf
110 SQUARE = 1
120 DELTA = 3
130 IF SQUARE > LIMIT THEN RETURN
140 LET SQUARE = SQUARE + DELTA
150 LET DELTA = DELTA + 2
160 LET NN = (DELTA/2)-1
170 GOTO 130

1000 REM 
1010 GOSUB 100: FOR N = 2 TO NN
1020 IF NOT FLAG(N) THEN GOTO 1060
1030 FOR K = N * N TO LIMIT STEP N
1040 LET FLAG(K) = FALSE
1050 NEXT K
1060 NEXT N
1070 REM COUNT THE PRIMES
1080 FOR N = 0 TO LIMIT
1090 IF NOT FLAG(N) THEN GOTO 1110
1100 LET COUNT=COUNT+1:REM PRINT N;", ";
1110 NEXT N

9997 PRINT:PRINT "FEITO: ";COUNT;" PRIMOS ENCONTRADOS."
9998 CALL -198:REM BEEP!
9999 END
